--      ___                       ___                       ___           ___           ___           ___           ___     
--     /__/\        ___          /__/\        ___          /  /\         /  /\         /__/\         /  /\         /  /\    
--    |  |::\      /  /\         \  \:\      /  /\        /  /:/_       /  /::\       |  |::\       /  /:/_       /  /:/_   
--    |  |:|:\    /  /:/          \  \:\    /  /:/       /  /:/ /\     /  /:/\:\      |  |:|:\     /  /:/ /\     /  /:/ /\  
--  __|__|:|\:\  /__/::\      _____\__\:\  /__/::\      /  /:/_/::\   /  /:/~/::\   __|__|:|\:\   /  /:/ /:/_   /  /:/ /::\ 
-- /__/::::| \:\ \__\/\:\__  /__/::::::::\ \__\/\:\__  /__/:/__\/\:\ /__/:/ /:/\:\ /__/::::| \:\ /__/:/ /:/ /\ /__/:/ /:/\:\
-- \  \:\~~\__\/    \  \:\/\ \  \:\~~\~~\/    \  \:\/\ \  \:\ /~~/:/ \  \:\/:/__\/ \  \:\~~\__\/ \  \:\/:/ /:/ \  \:\/:/~/:/
--  \  \:\           \__\::/  \  \:\  ~~~      \__\::/  \  \:\  /:/   \  \::/       \  \:\        \  \::/ /:/   \  \::/ /:/ 
--   \  \:\          /__/:/    \  \:\          /__/:/    \  \:\/:/     \  \:\        \  \:\        \  \:\/:/     \__\/ /:/  
--    \  \:\         \__\/      \  \:\         \__\/      \  \::/       \  \:\        \  \:\        \  \::/        /__/:/   
--     \__\/                     \__\/                     \__\/         \__\/         \__\/         \__\/         \__\/    
--=============================================================================================================================
--=============================================================================================================================
--TODO:
--=============================================================================================================================
--=============================================================================================================================
--All Credit and Copyrights go to (ESO EU) Dero - @Deryl
--I did my best to comment the code for others to learn from it ;)

-- Add-on properties
ESO_MG                               = {}
local ESO_MG                         = ESO_MG
ESO_MG.name                          = "MiniGames"
ESO_MG.description                   = "MiniGames"
ESO_MG.version                       = "1.0.0"
ESO_MG.savedVariablesName            = 'ESO_MG_SavedVariables'
ESO_MG.configVersion                 = 1
ESO_MG.configNamespace               = 'ESO_MG'

local EVENT_MANAGER                 = EVENT_MANAGER

-- Open Menu for MiniGames settings contained in MiniGamesMenu.lua
function ESO_MG.openmenu()
	SetGameCameraUIMode(true)
	if(MiniGamesMenu:IsHidden())then
		ESO_MG.Sound(ESO_MG_SN_Fade1)
	else
		ESO_MG.Sound(ESO_MG_SN_Click2)
	end
	MiniGamesMenu:SetHidden(not MiniGamesMenu:IsHidden())
	--Getting all available Data from Target
end

--Rotate Textures
function ESO_MG.RotateTexture(Duration,Texture,StartRot,EndRot)
	local ani, tl = CreateSimpleAnimation(ANIMATION_TEXTUREROTATE , Texture)
	ani:SetRotationValues(StartRot, EndRot)
	ani:SetDuration(Duration)
	tl:SetPlaybackType(ANIMATION_PLAYBACK_ONE_SHOT)
	tl:PlayFromStart()
end

--Fade In/Out Something
function ESO_MG.Fade(Duration,Item,StartAlp,EndAlp)
	local ani, tl = CreateSimpleAnimation(ANIMATION_ALPHA , Item)
	ani:SetAlphaValues(StartAlp, EndAlp)
	ani:SetDuration(Duration)
	tl:SetPlaybackType(ANIMATION_PLAYBACK_ONE_SHOT)
	tl:PlayFromStart()
end

--CodeLetters to En/DeCode A-Z 0-9
ESO_MG_CodeLetters = {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","0","1","2","3","4","5","6","7","8","9"}

--Encode a String
function ESO_MG.Encode(ESO_MG_CodeMe)
	ESO_MB_EncodedString = "" --Resets the EncodedString
	for i = 1 , string.len(ESO_MG_CodeMe) , 1 do
		CurrentLetterNum = "" -- Resets the CurrentLetterNum
		CodeLetterNum = math.random(table.getn(ESO_MG_CodeLetters)) --Gets a Random LetterNumber out of ESO_MG_CodeLetters
		CodeLetter = ESO_MG_CodeLetters[CodeLetterNum] --Gets the Letter Matching CodeLetterNum
		CurrentLetter = string.upper(string.sub(ESO_MG_CodeMe, i, i)) -- Gets the Current Letter or Number
		for j,k in pairs(ESO_MG_CodeLetters) do -- for each letter in the letters array
			if (CurrentLetter == k) then -- if the currentletter matches the current element of letters array
				CurrentLetterNum = j -- Gets the LetterNumber of the CurrentLetter
			elseif(j == table.getn(ESO_MG_CodeLetters) and CurrentLetterNum == "") then
				log("There is a wrong Letter in the Code!")
				return false
			end
		end
		NewLetterNum = CodeLetterNum + CurrentLetterNum
		if(NewLetterNum > table.getn(ESO_MG_CodeLetters)) then
			NewLetterNum = NewLetterNum - table.getn(ESO_MG_CodeLetters)
		end
		NewLetter = ESO_MG_CodeLetters[NewLetterNum]
		ESO_MB_EncodedString = ESO_MB_EncodedString .. NewLetter .. CodeLetter
	end
	return ESO_MB_EncodedString
end

--Decode a String
function ESO_MG.Decode(ESO_MG_CodeMe)
	ESO_MB_DecodedString = "" --Resets the EncodedString
	for i = 1 , string.len(ESO_MG_CodeMe) , 2 do
		CurrentLetterNum = "" -- Resets the CurrentLetterNum
		CodeLetterNum = "" -- Resets the CodeLetterNum
		CodeLetter = string.upper(string.sub(ESO_MG_CodeMe, i+1, i+1)) --Gets the CodeLetter
		CurrentLetter = string.upper(string.sub(ESO_MG_CodeMe, i, i)) -- Gets the Current Letter
		for j,k in pairs(ESO_MG_CodeLetters) do -- for each letter in the letters array
			if (CurrentLetter == k) then -- if the currentletter matches the current element of letters array
				CurrentLetterNum = j -- Gets the LetterNumber of the CurrentLetter
			elseif(j == table.getn(ESO_MG_CodeLetters) and CurrentLetterNum == "") then
				log("There is a wrong Letter in the Code! 1 ")
				return false
			end
			if (CodeLetter == k) then -- if the currentletter matches the current element of letters array
				CodeLetterNum = j -- Gets the LetterNumber of the CurrentLetter
			elseif(j == table.getn(ESO_MG_CodeLetters) and CodeLetterNum == "") then
				log("There is a wrong Letter in the Code!")
				return false
			end
		end
		NewLetterNum =  CurrentLetterNum - CodeLetterNum
		if(NewLetterNum < 1) then
			NewLetterNum = NewLetterNum + table.getn(ESO_MG_CodeLetters)
		end
		NewLetter = ESO_MG_CodeLetters[NewLetterNum]
		ESO_MB_DecodedString = ESO_MB_DecodedString .. NewLetter
	end
	return ESO_MB_DecodedString
end

-- Main function called by the /mg command
function ESO_MG.Main(arg)
	Command = string.lower(arg)
    if Command == "" or Command == "help" or Command == "info" or Command == "hilfe" then
        log("- Help -")
		log("/mg menu - Open the MiniGames Menu")
	elseif Command == "menu" then	
		ESO_MG.openmenu()
	elseif Command == "test1" then
		ListName = "Tra"
		ESO_MG.BuildList(ListName)
	elseif Command == "test2" then
		ListName = "Lala"
		ESO_MG.BuildList(ListName)
    end
end

-- Log a message to Chat
function ESO_MG.Log(msg)
    d(msg)
end

--Defaultdata to load if there are no Savedvars
function ESO_MG.Initdata()
	ESO_MG_DATA = {
		["MainAnchor"] = {128,GuiRoot,128,0,0},
		Cat1Hidden = 1 ,
		Cat1GridDim = 50 ,
		Cat1PlaySound = true,
		["Cat1Settings"] = {5,5},
		["Cat1Anchor"] = {128,GuiRoot,128,0,0},
		Cat2Hidden = 1 ,
		Cat2GridDim = 50 ,
		Cat2PlaySound = true,
		["Cat2Anchor"] = {128,GuiRoot,128,0,0},
		Cat3Hidden = 1 ,
		Cat3GridDim = 50 ,
		Cat3PlaySound = true,
		["Cat3Anchor"] = {128,GuiRoot,128,0,0},
		Cat4Hidden = 1 ,
		Cat4GridDim = 50 ,
		Cat4PlaySound = true,
		["Cat4Anchor"] = {128,GuiRoot,128,0,0},
		Cat5Hidden = 1 ,
		Cat5GridDim = 50 ,
		Cat5PlaySound = true,
	}
end

-- Initialise the add-on
function ESO_MG.OnAddOnLoaded(eventCode, addOnName)
    if (addOnName ~= ESO_MG.name) then return end
    -- Unregister for loaded event
    EVENT_MANAGER:UnregisterForEvent(ESO_MG.name, EVENT_ADD_ON_LOADED)

	-- Logging for Debugging
    log = ESO_MG.Log
    dbg = ESO_MG.Debug

    -- Slash command
    SLASH_COMMANDS["/mg"] = ESO_MG.Main
	
	--Initializing of Default Data
	ESO_MG.Initdata()
	
	--Loading saved Variables and setting item to save them
	ESO_MG_SavedData = ZO_SavedVars:NewAccountWide("ESO_MG_Settings", 1, nil, ESO_MG_DATA)
	
	--Build up the Menu
	ESO_MG.buildmenu()
	
	--Initialize the GameSettings
	ESO_MG.C1Init()
	
	--Setting the Listenings to false
	ESO_MG.C1listening = false
	ESO_MG.C1Selflistening = false
		
	--Initiate KeyBinding
	ZO_CreateStringId("SI_BINDING_NAME_OPEN_MINIGAME_MENU", "Open MiniGames Menu")
	
	--Register for the WaitFOrInvite Event
	EVENT_MANAGER:RegisterForEvent("C1WaitForAnyInvite", EVENT_CHAT_MESSAGE_CHANNEL, ESO_MG.C1WaitForInvites)
end

-- Register for the initialisation event
EVENT_MANAGER:RegisterForEvent(ESO_MG.name, EVENT_ADD_ON_LOADED, ESO_MG.OnAddOnLoaded)